###################################################################################################################################################
# To be used with OE0500 - Order Details
# Displays a warning if the margin is less than the minimum margin defined in warningMargin.  WarningMargin set to 10.  
#
# ------------------------------------------------------
# Copyright 2018 Orchid Systems 
# Permitted for use with Orchid Systems Modules only.
# The code is supplied on an as-is basis for training and demonstration purposes only and is not supported by Orchid Systems.
# If this code is deployed in a live production environment it is the responsibility of the End User to ensure 
# that it is operating as required.
###################################################################################################################################################


#################### Import Modules ###########################################
from accpac import *

import time
import datetime
import subprocess

###############################################################################

# Change the margin variable if you require something other than a 10 percent comparison.
warningMargin = 10

def onOpen():
	if rotoID != "OE0500":
		return 0 # don't do anything since the view is not OE0500 O/E sales order details.

	return Continue


def onBeforeVerify():
	rvspyTrace("onBeforeVerify")
	validateSalesMargin()
	return Continue

def validateSalesMargin():
	# Validate the sales margin based on the following requirement:
	#(Extended Sales - Extended Cost ) / (Extended Sales) * 100 > 10

	global warningMargin

	ext_sales = float(me.get("EXTINVMISC"))

	ext_cost = float(me.get("EXTOCOST"))

	if (ext_sales!=0):
	# sales margin formula:
		salesMargin = ((ext_sales - ext_cost) / (ext_sales)) * 100
		salesMargin = (salesMargin)

	#showMessage(str(ext_sales))
	#showMessage(str(ext_cost))

		if (salesMargin < warningMargin):
		# display warning.
			showMessageBox("Sales Margin " + "{:,.2f}".format(salesMargin) + "% does not exceed the " + str(warningMargin) + "% threshold")


